package com.zksy.web.controller.basicData;

import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmEnterpriseCreditRating;
import com.zksy.system.basicData.service.CrmEnterpriseCreditRatingService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 企业征信机构评分（天眼查）Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/crmEnterpriseCreditRating")
@Api(tags = "企业征信机构评分（天眼查）", description = "企业征信机构评分（天眼查）desc")
public class CrmEnterpriseCreditRatingController extends BaseController{

    @Autowired
    private CrmEnterpriseCreditRatingService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "企业征信机构评分（天眼查）搜索getById")
    public CrmEnterpriseCreditRating getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "企业征信机构评分（天眼查）分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "企业征信机构评分（天眼查）查询所有")
    public List<CrmEnterpriseCreditRating> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增企业征信机构评分（天眼查）
     */
    @PostMapping("/save")
    @ApiOperation(value = "企业征信机构评分（天眼查）新增")
    @Log(title = "新增企业征信机构评分（天眼查）", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmEnterpriseCreditRating crmEnterpriseCreditRating) {
        return service.save(crmEnterpriseCreditRating);
    }

    /**
     * 修改企业征信机构评分（天眼查）
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "企业征信机构评分（天眼查）修改")
    @Log(title = "修改企业征信机构评分（天眼查）", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmEnterpriseCreditRating crmEnterpriseCreditRating) {
        return service.updateById(crmEnterpriseCreditRating);
    }

    /**
     * 导入企业征信机构评分（天眼查）
     */
    @ApiOperation("企业征信机构评分（天眼查）导入")
    @Log(title = "企业征信机构评分（天眼查）", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmEnterpriseCreditRating> crmEnterpriseCreditRatingAll = service.list();
            List<CrmEnterpriseCreditRating> list = ExcelUtils.readMultipartFile(file, CrmEnterpriseCreditRating.class,CrmEnterpriseCreditRating.class.getDeclaredFields().length - 2);
            if(crmEnterpriseCreditRatingAll != null && crmEnterpriseCreditRatingAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("企业征信机构评分（天眼查）导出")
    @Log(title = "企业征信机构评分（天眼查）", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmEnterpriseCreditRating> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"企业征信机构评分（天眼查）",wrapperList,CrmEnterpriseCreditRating.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "企业征信机构评分（天眼查）", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除企业征信机构评分（天眼查）", notes = "删除企业征信机构评分（天眼查）")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"企业征信机构评分（天眼查）模板");
    }
}

